Index: tmp/org.txm.setups/nsis/Examples/makensis.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/makensis.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/makensis.nsi	(revision 2956)
@@ -1,26 +1,41 @@
 ;NSIS Setup Script
 ;--------------------------------
 
-!ifndef VERSION
-  !define VERSION 'anonymous-build'
+!pragma warning error all
+!pragma warning warning 7010 ; File /NonFatal
+
+!ifdef VER_MAJOR & VER_MINOR
+  !define /ifndef VER_REVISION 0
+  !define /ifndef VER_BUILD 0
 !endif
 
+!define /ifndef VERSION 'anonymous-build'
+
 ;--------------------------------
 ;Configuration
 
-!ifdef OUTFILE
-  OutFile "${OUTFILE}"
+!if ${NSIS_PTR_SIZE} > 4
+  !define BITS 64
+  !define NAMESUFFIX " (64 bit)"
 !else
-  OutFile ..\nsis-${VERSION}-setup.exe
+  !define BITS 32
+  !define NAMESUFFIX ""
 !endif
 
+!ifndef OUTFILE
+  !define OUTFILE "..\nsis${BITS}-${VERSION}-setup.exe"
+  !searchreplace OUTFILE "${OUTFILE}" nsis32 nsis
+!endif
+
+OutFile "${OUTFILE}"
+Unicode true
 SetCompressor /SOLID lzma
 
 InstType "Full"
 InstType "Lite"
 InstType "Minimal"
 
-InstallDir $PROGRAMFILES\NSIS
+InstallDir $PROGRAMFILES${BITS}\NSIS
 InstallDirRegKey HKLM Software\NSIS ""
 
 RequestExecutionLevel admin
@@ -33,44 +48,37 @@
 !include "LogicLib.nsh"
 !include "Memento.nsh"
 !include "WordFunc.nsh"
+!include "Util.nsh"
+!include "Integration.nsh"
 
 ;--------------------------------
-;Functions
-
-!ifdef VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD
-
-  !insertmacro VersionCompare
-
-!endif
-
-;--------------------------------
-;Definitions
-
-!define SHCNE_ASSOCCHANGED 0x8000000
-!define SHCNF_IDLIST 0
-
-;--------------------------------
 ;Configuration
 
 ;Names
 Name "NSIS"
-Caption "NSIS ${VERSION} Setup"
+Caption "NSIS ${VERSION}${NAMESUFFIX} Setup"
 
+!define REG_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS"
+
 ;Memento Settings
 !define MEMENTO_REGISTRY_ROOT HKLM
-!define MEMENTO_REGISTRY_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS"
+!define MEMENTO_REGISTRY_KEY "${REG_UNINST_KEY}"
 
 ;Interface Settings
 !define MUI_ABORTWARNING
 
+!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\nsis3-install.ico"
+!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\nsis3-uninstall.ico"
+
 !define MUI_HEADERIMAGE
-!define MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\nsis.bmp"
+!define MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Header\nsis3-branding.bmp"
+!define MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\nsis3-branding.bmp"
 
 !define MUI_COMPONENTSPAGE_SMALLDESC
 
 ;Pages
 !define MUI_WELCOMEPAGE_TITLE "Welcome to the NSIS ${VERSION} Setup Wizard"
-!define MUI_WELCOMEPAGE_TEXT "This wizard will guide you through the installation of NSIS (Nullsoft Scriptable Install System) ${VERSION}, the next generation of the Windows installer and uninstaller system that doesn't suck and isn't huge.$\r$\n$\r$\nNSIS 2 includes a new Modern User Interface, LZMA compression, support for multiple languages and an easy plug-in system.$\r$\n$\r$\n$_CLICK"
+!define MUI_WELCOMEPAGE_TEXT "This wizard will guide you through the installation of NSIS (Nullsoft Scriptable Install System) ${VERSION}, the next generation of the Windows installer and uninstaller system that doesn't suck and isn't huge.$\r$\n$\r$\nNSIS includes a Modern User Interface, LZMA compression, support for multiple languages and an easy plug-in system.$\r$\n$\r$\n$_CLICK"
 
 !insertmacro MUI_PAGE_WELCOME
 !insertmacro MUI_PAGE_LICENSE "..\COPYING"
@@ -102,8 +110,36 @@
 !insertmacro MUI_LANGUAGE "English"
 
 ;--------------------------------
+;Version information
+
+!ifdef VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD
+VIProductVersion ${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}
+VIAddVersionKey "FileVersion" "${VERSION}"
+VIAddVersionKey "FileDescription" "NSIS Setup"
+VIAddVersionKey "LegalCopyright" "http://nsis.sf.net/License"
+!endif
+
+;--------------------------------
 ;Installer Sections
 
+!macro InstallPlugin pi
+  !if ${BITS} >= 64
+    File "/oname=$InstDir\Plugins\amd64-unicode\${pi}.dll" ..\Plugins\amd64-unicode\${pi}.dll
+  !else
+    File "/oname=$InstDir\Plugins\x86-ansi\${pi}.dll" ..\Plugins\x86-ansi\${pi}.dll
+    File "/oname=$InstDir\Plugins\x86-unicode\${pi}.dll" ..\Plugins\x86-unicode\${pi}.dll
+  !endif
+!macroend
+
+!macro InstallStub stub
+  !if ${BITS} >= 64
+    File ..\Stubs\${stub}-amd64-unicode
+  !else
+    File ..\Stubs\${stub}-x86-ansi
+    File ..\Stubs\${stub}-x86-unicode
+  !endif
+!macroend
+
 ${MementoSection} "NSIS Core Files (required)" SecCore
 
   SetDetailsPrint textonly
@@ -114,29 +150,44 @@
   SetOutPath $INSTDIR
   RMDir /r $SMPROGRAMS\NSIS
 
+  IfFileExists $INSTDIR\nsisconf.nsi "" +2
+  Rename $INSTDIR\nsisconf.nsi $INSTDIR\nsisconf.nsh
+  SetOverwrite off
+  File ..\nsisconf.nsh
+
   SetOverwrite on
   File ..\makensis.exe
   File ..\makensisw.exe
   File ..\COPYING
   File ..\NSIS.chm
-  !searchparse /file "..\NSIS.chm" "ITSF" VALIDATE_CHM
+  !pragma verifychm "..\NSIS.chm"
+  !if /FileExists "..\NSIS.exe"
+    !if /FileExists "..\NSIS.exe.manifest"
+      File "..\NSIS.exe.manifest"
+    !endif
+  !else
+    !define NO_NSISMENU_HTML 1
+    !makensis '-v2 "NSISMenu.nsi" "-XOutFile ..\NSIS.exe"' = 0
+  !endif
   File ..\NSIS.exe
-  File /nonfatal ..\NSIS.exe.manifest
 
-  IfFileExists $INSTDIR\nsisconf.nsi "" +2
-  Rename $INSTDIR\nsisconf.nsi $INSTDIR\nsisconf.nsh
-  SetOverwrite off
-  File ..\nsisconf.nsh
-  SetOverwrite on
+  SetOutPath $INSTDIR\Bin
+  File ..\Bin\makensis.exe
+!ifdef USE_NEW_ZLIB
+  File ..\Bin\zlib.dll
+!else
+  File ..\Bin\zlib1.dll
+!endif
 
   SetOutPath $INSTDIR\Stubs
-  File ..\Stubs\bzip2
-  File ..\Stubs\bzip2_solid
-  File ..\Stubs\lzma
-  File ..\Stubs\lzma_solid
-  File ..\Stubs\zlib
-  File ..\Stubs\zlib_solid
   File ..\Stubs\uninst
+  !insertmacro InstallStub bzip2
+  !insertmacro InstallStub bzip2_solid
+  !insertmacro InstallStub lzma
+  !insertmacro InstallStub lzma_solid
+  !insertmacro InstallStub zlib
+  !insertmacro InstallStub zlib_solid
+  
 
   SetOutPath $INSTDIR\Include
   File ..\Include\WinMessages.nsh
@@ -157,6 +208,7 @@
   File ..\Include\MultiUser.nsh
   File ..\Include\VB6RunTime.nsh
   File ..\Include\Util.nsh
+  File ..\Include\Integration.nsh
   File ..\Include\WinCore.nsh
 
   SetOutPath $INSTDIR\Include\Win
@@ -164,6 +216,8 @@
   File ..\Include\Win\WinError.nsh
   File ..\Include\Win\WinNT.nsh
   File ..\Include\Win\WinUser.nsh
+  File ..\Include\Win\COM.nsh
+  File ..\Include\Win\Propkey.nsh
 
   SetOutPath $INSTDIR\Docs\StrFunc
   File ..\Docs\StrFunc\StrFunc.txt
@@ -174,12 +228,14 @@
   SetOutPath $INSTDIR\Docs\makensisw
   File ..\Docs\makensisw\*.txt
 
-  SetOutPath $INSTDIR\Menu
-  File ..\Menu\*.html
-  SetOutPath $INSTDIR\Menu\images
-  File ..\Menu\images\header.gif
-  File ..\Menu\images\line.gif
-  File ..\Menu\images\site.gif
+  !ifndef NO_NSISMENU_HTML
+    SetOutPath $INSTDIR\Menu
+    File ..\Menu\*.html
+    SetOutPath $INSTDIR\Menu\images
+    File ..\Menu\images\header.gif
+    File ..\Menu\images\line.gif
+    File ..\Menu\images\site.gif
+  !endif
 
   Delete $INSTDIR\makensis.htm
   Delete $INSTDIR\Docs\*.html
@@ -187,24 +243,36 @@
   RMDir $INSTDIR\Docs
 
   SetOutPath $INSTDIR\Bin
-  File ..\Bin\LibraryLocal.exe
-  File ..\Bin\RegTool.bin
+  !if ${BITS} >= 64
+    File /NonFatal  ..\Bin\RegTool-x86.bin
+    File            ..\Bin\RegTool-amd64.bin
+  !else
+    File            ..\Bin\RegTool-x86.bin
+    !if /FileExists ..\Bin\RegTool-amd64.bin ; It is unlikely that this exists, avoid the /NonFatal warning.
+      File          ..\Bin\RegTool-amd64.bin
+    !endif
+  !endif
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\TypeLib.dll
+  CreateDirectory $INSTDIR\Plugins\x86-ansi
+  CreateDirectory $INSTDIR\Plugins\x86-unicode
+  !if ${BITS} >= 64
+    CreateDirectory $INSTDIR\Plugins\amd64-unicode
+  !endif
+  !insertmacro InstallPlugin TypeLib
 
   ReadRegStr $R0 HKCR ".nsi" ""
   StrCmp $R0 "NSISFile" 0 +2
     DeleteRegKey HKCR "NSISFile"
 
   WriteRegStr HKCR ".nsi" "" "NSIS.Script"
+  WriteRegStr HKCR ".nsi" "PerceivedType" "text"
   WriteRegStr HKCR "NSIS.Script" "" "NSIS Script File"
   WriteRegStr HKCR "NSIS.Script\DefaultIcon" "" "$INSTDIR\makensisw.exe,1"
   ReadRegStr $R0 HKCR "NSIS.Script\shell\open\command" ""
-  StrCmp $R0 "" 0 no_nsiopen
+  ${If} $R0 == ""
     WriteRegStr HKCR "NSIS.Script\shell" "" "open"
     WriteRegStr HKCR "NSIS.Script\shell\open\command" "" 'notepad.exe "%1"'
-  no_nsiopen:
+  ${EndIf}
   WriteRegStr HKCR "NSIS.Script\shell\compile" "" "Compile NSIS Script"
   WriteRegStr HKCR "NSIS.Script\shell\compile\command" "" '"$INSTDIR\makensisw.exe" "%1"'
   WriteRegStr HKCR "NSIS.Script\shell\compile-compressor" "" "Compile NSIS Script (Choose Compressor)"
@@ -215,15 +283,16 @@
     DeleteRegKey HKCR "NSHFile"
 
   WriteRegStr HKCR ".nsh" "" "NSIS.Header"
+  WriteRegStr HKCR ".nsh" "PerceivedType" "text"
   WriteRegStr HKCR "NSIS.Header" "" "NSIS Header File"
-  WriteRegStr HKCR "NSIS.Header\DefaultIcon" "" "$INSTDIR\makensisw.exe,1"
+  WriteRegStr HKCR "NSIS.Header\DefaultIcon" "" "$INSTDIR\makensisw.exe,2"
   ReadRegStr $R0 HKCR "NSIS.Header\shell\open\command" ""
-  StrCmp $R0 "" 0 no_nshopen
+  ${If} $R0 == ""
     WriteRegStr HKCR "NSIS.Header\shell" "" "open"
     WriteRegStr HKCR "NSIS.Header\shell\open\command" "" 'notepad.exe "%1"'
-  no_nshopen:
+  ${EndIf}
 
-  System::Call 'Shell32::SHChangeNotify(i ${SHCNE_ASSOCCHANGED}, i ${SHCNF_IDLIST}, i 0, i 0)'
+  ${NotifyShell_AssocChanged}
 
 ${MementoSectionEnd}
 
@@ -238,7 +307,8 @@
   File ..\Examples\makensis.nsi
   File ..\Examples\example1.nsi
   File ..\Examples\example2.nsi
-  File ..\Examples\viewhtml.nsi
+  File ..\Examples\install-per-user.nsi
+  File ..\Examples\install-shared.nsi
   File ..\Examples\waplugin.nsi
   File ..\Examples\bigtest.nsi
   File ..\Examples\primes.nsi
@@ -248,7 +318,6 @@
   File ..\Examples\languages.nsi
   File ..\Examples\Library.nsi
   File ..\Examples\VersionInfo.nsi
-  File ..\Examples\UserVars.nsi
   File ..\Examples\LogicLib.nsi
   File ..\Examples\silent.nsi
   File ..\Examples\StrFunc.nsi
@@ -262,6 +331,8 @@
   File ..\Examples\WordFunc.ini
   File ..\Examples\WordFuncTest.nsi
   File ..\Examples\Memento.nsi
+  File ..\Examples\unicode.nsi
+  File ..\Examples\NSISMenu.nsi
 
   SetOutPath $INSTDIR\Examples\Plugin
   File ..\Examples\Plugin\exdll.c
@@ -276,8 +347,9 @@
 
   SetOutPath $INSTDIR\Examples\Plugin\nsis
   File ..\Examples\Plugin\nsis\pluginapi.h
-  File ..\Examples\Plugin\nsis\pluginapi.lib
+  File /nonfatal ..\Examples\Plugin\nsis\pluginapi*.lib
   File ..\Examples\Plugin\nsis\api.h
+  File ..\Examples\Plugin\nsis\nsis_tchar.h
 
 ${MementoSectionEnd}
 
@@ -299,10 +371,10 @@
   SectionIn 1 2
   SetOutPath $INSTDIR
 !ifndef NO_STARTMENUSHORTCUTS
-  CreateShortCut "$SMPROGRAMS\NSIS.lnk" "$INSTDIR\NSIS.exe"
+  CreateShortcut "$SMPROGRAMS\NSIS${NAMESUFFIX}.lnk" "$INSTDIR\NSIS.exe"
 !endif
 
-  CreateShortCut "$DESKTOP\NSIS.lnk" "$INSTDIR\NSIS.exe"
+  CreateShortcut "$DESKTOP\NSIS${NAMESUFFIX}.lnk" "$INSTDIR\NSIS.exe"
 
 ${MementoSectionEnd}
 
@@ -440,11 +512,10 @@
   SetOutPath $INSTDIR\Bin
   File ..\Bin\MakeLangID.exe
 
-  !insertmacro SectionFlagIsSet ${SecInterfacesModernUI} ${SF_SELECTED} mui nomui
-  mui:
+  ${If} ${SectionIsSelected} ${SecInterfacesModernUI}
     SetOutPath "$INSTDIR\Contrib\Language files"
     File "..\Contrib\Language files\*.nsh"
-  nomui:
+  ${EndIf}
 
 ${MementoSectionEnd}
 
@@ -479,8 +550,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\Banner.dll
+  !insertmacro InstallPlugin Banner
   SetOutPath $INSTDIR\Docs\Banner
   File ..\Docs\Banner\Readme.txt
   SetOutPath $INSTDIR\Examples\Banner
@@ -494,8 +564,7 @@
   SetDetailsPrint listonly
 
   SectionIn 1
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\LangDLL.dll
+  !insertmacro InstallPlugin LangDLL
 ${MementoSectionEnd}
 
 ${MementoSection} "nsExec" SecPluginsnsExec
@@ -506,8 +575,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\nsExec.dll
+  !insertmacro InstallPlugin nsExec
   SetOutPath $INSTDIR\Docs\nsExec
   File ..\Docs\nsExec\nsExec.txt
   SetOutPath $INSTDIR\Examples\nsExec
@@ -522,8 +590,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\splash.dll
+  !insertmacro InstallPlugin splash
   SetOutPath $INSTDIR\Docs\Splash
   File ..\Docs\Splash\splash.txt
   SetOutPath $INSTDIR\Examples\Splash
@@ -538,8 +605,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\advsplash.dll
+  !insertmacro InstallPlugin advsplash
   SetOutPath $INSTDIR\Docs\AdvSplash
   File ..\Docs\AdvSplash\advsplash.txt
   SetOutPath $INSTDIR\Examples\AdvSplash
@@ -554,8 +620,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\BgImage.dll
+  !insertmacro InstallPlugin BgImage
   SetOutPath $INSTDIR\Docs\BgImage
   File ..\Docs\BgImage\BgImage.txt
   SetOutPath $INSTDIR\Examples\BgImage
@@ -570,8 +635,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\InstallOptions.dll
+  !insertmacro InstallPlugin InstallOptions
   SetOutPath $INSTDIR\Docs\InstallOptions
   File ..\Docs\InstallOptions\Readme.html
   File ..\Docs\InstallOptions\Changelog.txt
@@ -594,8 +658,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\nsDialogs.dll
+  !insertmacro InstallPlugin nsDialogs
   SetOutPath $INSTDIR\Examples\nsDialogs
   File ..\Examples\nsDialogs\example.nsi
   File ..\Examples\nsDialogs\InstallOptions.nsi
@@ -615,8 +678,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\Math.dll
+  !insertmacro InstallPlugin Math
   SetOutPath $INSTDIR\Docs\Math
   File ..\Docs\Math\Math.txt
   SetOutPath $INSTDIR\Examples\Math
@@ -635,8 +697,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\nsisdl.dll
+  !insertmacro InstallPlugin nsisdl
   SetOutPath $INSTDIR\Docs\NSISdl
   File ..\Docs\NSISdl\ReadMe.txt
   File ..\Docs\NSISdl\License.txt
@@ -650,8 +711,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\System.dll
+  !insertmacro InstallPlugin System
   SetOutPath $INSTDIR\Docs\System
   File ..\Docs\System\System.html
   File ..\Docs\System\WhatsNew.txt
@@ -670,8 +730,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\StartMenu.dll
+  !insertmacro InstallPlugin StartMenu
   SetOutPath $INSTDIR\Docs\StartMenu
   File ..\Docs\StartMenu\Readme.txt
   SetOutPath $INSTDIR\Examples\StartMenu
@@ -686,8 +745,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\UserInfo.dll
+  !insertmacro InstallPlugin UserInfo
   SetOutPath $INSTDIR\Examples\UserInfo
   File ..\Examples\UserInfo\UserInfo.nsi
 ${MementoSectionEnd}
@@ -700,8 +758,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\Dialer.dll
+  !insertmacro InstallPlugin Dialer
   SetOutPath $INSTDIR\Docs\Dialer
   File ..\Docs\Dialer\Dialer.txt
 ${MementoSectionEnd}
@@ -714,8 +771,7 @@
 
   SectionIn 1
 
-  SetOutPath $INSTDIR\Plugins
-  File ..\Plugins\VPatch.dll
+  !insertmacro InstallPlugin VPatch
   SetOutPath $INSTDIR\Examples\VPatch
   File ..\Examples\VPatch\example.nsi
   File ..\Examples\VPatch\oldfile.txt
@@ -739,30 +795,19 @@
   ; * Always install the English language file
   ; * Always install default icons / bitmaps
 
-  !insertmacro SectionFlagIsSet ${SecInterfacesModernUI} ${SF_SELECTED} mui nomui
+  ${If} ${SectionIsSelected} ${SecInterfacesModernUI}
 
-    mui:
-
     SetDetailsPrint textonly
     DetailPrint "Configuring Modern UI..."
     SetDetailsPrint listonly
 
-    !insertmacro SectionFlagIsSet ${SecLangFiles} ${SF_SELECTED} langfiles nolangfiles
-
-      nolangfiles:
-
+    ${IfNot} ${SectionIsSelected} ${SecLangFiles}
       SetOutPath "$INSTDIR\Contrib\Language files"
       File "..\Contrib\Language files\English.nlf"
-      SetOutPath "$INSTDIR\Contrib\Language files"
       File "..\Contrib\Language files\English.nsh"
+    ${EndIf}
 
-    langfiles:
-
-    !insertmacro SectionFlagIsSet ${SecGraphics} ${SF_SELECTED} graphics nographics
-
-      nographics:
-
-      SetOutPath $INSTDIR\Contrib\Graphics
+    ${IfNot} ${SectionIsSelected} ${SecGraphics}
       SetOutPath $INSTDIR\Contrib\Graphics\Checks
       File "..\Contrib\Graphics\Checks\modern.bmp"
       SetOutPath $INSTDIR\Contrib\Graphics\Icons
@@ -772,11 +817,10 @@
       File "..\Contrib\Graphics\Header\nsis.bmp"
       SetOutPath $INSTDIR\Contrib\Graphics\Wizard
       File "..\Contrib\Graphics\Wizard\win.bmp"
+    ${EndIf}
 
-    graphics:
+  ${EndIf}
 
-  nomui:
-
   SetDetailsPrint textonly
   DetailPrint "Creating Registry Keys..."
   SetDetailsPrint listonly
@@ -791,19 +835,23 @@
   WriteRegDword HKLM "Software\NSIS" "VersionBuild" "${VER_BUILD}"
 !endif
 
-  WriteRegExpandStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "UninstallString" '"$INSTDIR\uninst-nsis.exe"'
-  WriteRegExpandStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "InstallLocation" "$INSTDIR"
-  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "DisplayName" "Nullsoft Install System"
-  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "DisplayIcon" "$INSTDIR\NSIS.exe,0"
-  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "DisplayVersion" "${VERSION}"
+  WriteRegExpandStr HKLM "${REG_UNINST_KEY}" "UninstallString" '"$INSTDIR\uninst-nsis.exe"'
+  ;WriteRegStr HKLM "${REG_UNINST_KEY}" "QuietUninstallString" '"$INSTDIR\uninst-nsis.exe" /S' ; Ideally WACK would use this
+  WriteRegExpandStr HKLM "${REG_UNINST_KEY}" "InstallLocation" "$INSTDIR"
+  WriteRegStr HKLM "${REG_UNINST_KEY}" "DisplayName" "Nullsoft Install System${NAMESUFFIX}"
+  WriteRegStr HKLM "${REG_UNINST_KEY}" "DisplayIcon" "$INSTDIR\uninst-nsis.exe,0"
+  WriteRegStr HKLM "${REG_UNINST_KEY}" "DisplayVersion" "${VERSION}"
 !ifdef VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD
-  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "VersionMajor" "${VER_MAJOR}"
-  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "VersionMinor" "${VER_MINOR}.${VER_REVISION}"
+  WriteRegDWORD HKLM "${REG_UNINST_KEY}" "VersionMajor" "${VER_MAJOR}" ; Required by WACK
+  WriteRegDWORD HKLM "${REG_UNINST_KEY}" "VersionMinor" "${VER_MINOR}" ; Required by WACK
 !endif
-  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "URLInfoAbout" "http://nsis.sourceforge.net/"
-  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "HelpLink" "http://nsis.sourceforge.net/Support"
-  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "NoModify" "1"
-  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "NoRepair" "1"
+  WriteRegStr HKLM "${REG_UNINST_KEY}" "Publisher" "Nullsoft and Contributors" ; Required by WACK
+  WriteRegStr HKLM "${REG_UNINST_KEY}" "URLInfoAbout" "https://nsis.sourceforge.io/"
+  WriteRegStr HKLM "${REG_UNINST_KEY}" "HelpLink" "https://nsis.sourceforge.io/Support"
+  WriteRegDWORD HKLM "${REG_UNINST_KEY}" "NoModify" "1"
+  WriteRegDWORD HKLM "${REG_UNINST_KEY}" "NoRepair" "1"
+  ${MakeARPInstallDate} $1
+  WriteRegStr HKLM "${REG_UNINST_KEY}" "InstallDate" $1
 
   WriteUninstaller $INSTDIR\uninst-nsis.exe
 
@@ -862,15 +910,15 @@
 Function PageReinstall
 
   ReadRegStr $R0 HKLM "Software\NSIS" ""
+  ReadRegStr $R1 HKLM "${REG_UNINST_KEY}" "UninstallString"
+  ${IfThen} "$R0$R1" == "" ${|} Abort ${|}
 
-  ${If} $R0 == ""
-    Abort
-  ${EndIf}
-
+  StrCpy $R4 "older"
   ReadRegDWORD $R0 HKLM "Software\NSIS" "VersionMajor"
   ReadRegDWORD $R1 HKLM "Software\NSIS" "VersionMinor"
   ReadRegDWORD $R2 HKLM "Software\NSIS" "VersionRevision"
   ReadRegDWORD $R3 HKLM "Software\NSIS" "VersionBuild"
+  ${IfThen} $R0 = 0 ${|} StrCpy $R4 "unknown" ${|} ; Anonymous builds have no version number
   StrCpy $R0 $R0.$R1.$R2.$R3
 
   ${VersionCompare} ${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD} $R0 $R0
@@ -881,7 +929,7 @@
     !insertmacro MUI_HEADER_TEXT "Already Installed" "Choose the maintenance option to perform."
     StrCpy $R0 "2"
   ${ElseIf} $R0 == 1
-    StrCpy $R1 "An older version of NSIS is installed on your system. It's recommended that you uninstall the current version before installing. Select the operation you want to perform and click Next to continue."
+    StrCpy $R1 "An $R4 version of NSIS is installed on your system. It's recommended that you uninstall the current version before installing. Select the operation you want to perform and click Next to continue."
     StrCpy $R2 "Uninstall before installing"
     StrCpy $R3 "Do not uninstall"
     !insertmacro MUI_HEADER_TEXT "Already Installed" "Choose how you want to install NSIS."
@@ -940,34 +988,40 @@
 
   ${NSD_GetState} $R2 $R1
 
-  StrCmp $R0 "1" 0 +2
+  StrCmp $R0 "1" 0 +2 ; Existing install is not the same version?
     StrCmp $R1 "1" reinst_uninstall reinst_done
 
-  StrCmp $R0 "2" 0 +3
-    StrCmp $R1 "1" reinst_done reinst_uninstall
+  StrCmp $R1 "1" reinst_done ; Same version, skip to add/reinstall components?
 
   reinst_uninstall:
-  ReadRegStr $R1 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "UninstallString"
+  ReadRegStr $R1 HKLM "${REG_UNINST_KEY}" "UninstallString"
 
   ;Run uninstaller
-  HideWindow
+    HideWindow
 
     ClearErrors
-    ExecWait '$R1 _?=$INSTDIR'
+    ExecWait '$R1 _?=$INSTDIR' $0
 
-    IfErrors no_remove_uninstaller
-    IfFileExists "$INSTDIR\makensis.exe" no_remove_uninstaller
+    BringToFront
 
+    ${IfThen} ${Errors} ${|} StrCpy $0 2 ${|} ; ExecWait failed, set fake exit code
+
+    ${If} $0 <> 0
+    ${OrIf} ${FileExists} "$INSTDIR\Bin\makensis.exe"
+      ${If} $0 = 1 ; User aborted uninstaller?
+        StrCmp $R0 "2" 0 +2 ; Is the existing install the same version?
+          Quit ; ...yes, already installed, we are done
+        Abort
+      ${EndIf}
+      MessageBox MB_ICONEXCLAMATION "Unable to uninstall!"
+      Abort
+    ${Else}
+      StrCpy $0 $R1 1
+      ${IfThen} $0 == '"' ${|} StrCpy $R1 $R1 -1 1 ${|} ; Strip quotes from UninstallString
       Delete $R1
       RMDir $INSTDIR
+    ${EndIf}
 
-    no_remove_uninstaller:
-
-  StrCmp $R0 "2" 0 +2
-    Quit
-
-  BringToFront
-
   reinst_done:
 
 FunctionEnd
@@ -975,16 +1029,12 @@
 !endif # VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD
 
 Function ShowReleaseNotes
-  ${If} ${FileExists} $WINDIR\hh.exe
-    StrCpy $0 $WINDIR\hh.exe
+  StrCpy $0 $WINDIR\hh.exe
+  ${IfNotThen} ${FileExists} $0 ${|} SearchPath $0 hh.exe ${|}
+  ${If} ${FileExists} $0
     Exec '"$0" mk:@MSITStore:$INSTDIR\NSIS.chm::/SectionF.1.html'
   ${Else}
-    SearchPath $0 hh.exe
-    ${If} ${FileExists} $0
-      Exec '"$0" mk:@MSITStore:$INSTDIR\NSIS.chm::/SectionF.1.html'
-    ${Else}
-      ExecShell "open" "http://nsis.sourceforge.net/Docs/AppendixF.html#F.1"
-    ${EndIf}
+    ExecShell "" "https://nsis.sourceforge.io/Docs/AppendixF.html#F.1"
   ${EndIf}
 FunctionEnd
 
@@ -997,7 +1047,7 @@
   DetailPrint "Uninstalling NSI Development Shell Extensions..."
   SetDetailsPrint listonly
 
-  IfFileExists $INSTDIR\makensis.exe nsis_installed
+  IfFileExists $INSTDIR\Bin\makensis.exe nsis_installed
     MessageBox MB_YESNO "It does not appear that NSIS is installed in the directory '$INSTDIR'.$\r$\nContinue anyway (not recommended)?" IDYES nsis_installed
     Abort "Uninstall aborted by user"
   nsis_installed:
@@ -1006,31 +1056,32 @@
   DetailPrint "Deleting Registry Keys..."
   SetDetailsPrint listonly
 
-  ReadRegStr $R0 HKCR ".nsi" ""
-  StrCmp $R0 "NSIS.Script" 0 +2
-    DeleteRegKey HKCR ".nsi"
+  !macro AssocDeleteFileExtAndProgId _hkey _dotext _pid
+  ReadRegStr $R0 ${_hkey} "Software\Classes\${_dotext}" ""
+  StrCmp $R0 "${_pid}" 0 +2
+    DeleteRegKey ${_hkey} "Software\Classes\${_dotext}"
 
-  ReadRegStr $R0 HKCR ".nsh" ""
-  StrCmp $R0 "NSIS.Header" 0 +2
-    DeleteRegKey HKCR ".nsh"
+  DeleteRegKey ${_hkey} "Software\Classes\${_pid}"
+  !macroend
 
-  DeleteRegKey HKCR "NSIS.Script"
-  DeleteRegKey HKCR "NSIS.Header"
+  !insertmacro AssocDeleteFileExtAndProgId HKLM ".nsi" "NSIS.Script"
+  !insertmacro AssocDeleteFileExtAndProgId HKLM ".nsh" "NSIS.Header"
 
-  System::Call 'Shell32::SHChangeNotify(i ${SHCNE_ASSOCCHANGED}, i ${SHCNF_IDLIST}, i 0, i 0)'
+  ${NotifyShell_AssocChanged}
 
-  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS"
+  DeleteRegKey HKLM "${REG_UNINST_KEY}"
   DeleteRegKey HKLM "Software\NSIS"
 
   SetDetailsPrint textonly
   DetailPrint "Deleting Files..."
   SetDetailsPrint listonly
 
-  Delete $SMPROGRAMS\NSIS.lnk
-  Delete $DESKTOP\NSIS.lnk
+  Delete "$SMPROGRAMS\NSIS${NAMESUFFIX}.lnk"
+  Delete "$DESKTOP\NSIS${NAMESUFFIX}.lnk"
   Delete $INSTDIR\makensis.exe
   Delete $INSTDIR\makensisw.exe
   Delete $INSTDIR\NSIS.exe
+  Delete $INSTDIR\NSIS.exe.manifest
   Delete $INSTDIR\license.txt
   Delete $INSTDIR\COPYING
   Delete $INSTDIR\uninst-nsis.exe
Index: tmp/org.txm.setups/nsis/Examples/example1.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/example1.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/example1.nsi	(revision 2956)
@@ -4,6 +4,8 @@
 ; optional settings are left to their default settings. The installer simply 
 ; prompts the user asking them where to install, and drops a copy of example1.nsi
 ; there. 
+;
+; example2.nsi expands on this by adding a uninstaller and start menu shortcuts.
 
 ;--------------------------------
 
@@ -13,12 +15,15 @@
 ; The file to write
 OutFile "example1.exe"
 
+; Request application privileges for Windows Vista
+RequestExecutionLevel user
+
+; Build Unicode installer
+Unicode True
+
 ; The default installation directory
 InstallDir $DESKTOP\Example1
 
-; Request application privileges for Windows Vista
-RequestExecutionLevel user
-
 ;--------------------------------
 
 ; Pages
Index: tmp/org.txm.setups/nsis/Examples/example2.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/example2.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/example2.nsi	(revision 2956)
@@ -3,7 +3,10 @@
 ; This script is based on example1.nsi, but it remember the directory, 
 ; has uninstall support and (optionally) installs start menu shortcuts.
 ;
-; It will install example2.nsi into a directory that the user selects,
+; It will install example2.nsi into a directory that the user selects.
+;
+; See install-shared.nsi for a more robust way of checking for administrator rights.
+; See install-per-user.nsi for a file association example.
 
 ;--------------------------------
 
@@ -13,6 +16,12 @@
 ; The file to write
 OutFile "example2.exe"
 
+; Request application privileges for Windows Vista and higher
+RequestExecutionLevel admin
+
+; Build Unicode installer
+Unicode True
+
 ; The default installation directory
 InstallDir $PROGRAMFILES\Example2
 
@@ -20,9 +29,6 @@
 ; overwrite the old one automatically)
 InstallDirRegKey HKLM "Software\NSIS_Example2" "Install_Dir"
 
-; Request application privileges for Windows Vista
-RequestExecutionLevel admin
-
 ;--------------------------------
 
 ; Pages
@@ -55,7 +61,7 @@
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Example2" "UninstallString" '"$INSTDIR\uninstall.exe"'
   WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Example2" "NoModify" 1
   WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Example2" "NoRepair" 1
-  WriteUninstaller "uninstall.exe"
+  WriteUninstaller "$INSTDIR\uninstall.exe"
   
 SectionEnd
 
@@ -63,9 +69,9 @@
 Section "Start Menu Shortcuts"
 
   CreateDirectory "$SMPROGRAMS\Example2"
-  CreateShortCut "$SMPROGRAMS\Example2\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
-  CreateShortCut "$SMPROGRAMS\Example2\Example2 (MakeNSISW).lnk" "$INSTDIR\example2.nsi" "" "$INSTDIR\example2.nsi" 0
-  
+  CreateShortcut "$SMPROGRAMS\Example2\Uninstall.lnk" "$INSTDIR\uninstall.exe"
+  CreateShortcut "$SMPROGRAMS\Example2\Example2 (MakeNSISW).lnk" "$INSTDIR\example2.nsi"
+
 SectionEnd
 
 ;--------------------------------
@@ -83,9 +89,9 @@
   Delete $INSTDIR\uninstall.exe
 
   ; Remove shortcuts, if any
-  Delete "$SMPROGRAMS\Example2\*.*"
+  Delete "$SMPROGRAMS\Example2\*.lnk"
 
-  ; Remove directories used
+  ; Remove directories
   RMDir "$SMPROGRAMS\Example2"
   RMDir "$INSTDIR"
 
Index: tmp/org.txm.setups/nsis/Examples/one-section.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/one-section.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/one-section.nsi	(revision 2956)
@@ -20,7 +20,8 @@
 
 ; Pages
 
-Page components
+Page Components
+Page InstFiles
 
 ;--------------------------------
 
@@ -69,11 +70,11 @@
     !insertmacro RadioButton ${g1o2}
     !insertmacro RadioButton ${g1o3}
   !insertmacro EndRadioButtons
-	
+
   !insertmacro StartRadioButtons $2
     !insertmacro RadioButton ${g2o1}
     !insertmacro RadioButton ${g2o2}
     !insertmacro RadioButton ${g2o3}
   !insertmacro EndRadioButtons
-	
+
 FunctionEnd
\ No newline at end of file
Index: tmp/org.txm.setups/nsis/Examples/gfx.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/gfx.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/gfx.nsi	(revision 2956)
@@ -29,7 +29,7 @@
 ; It is not enough to just add the placeholder, we must set the image too...
 ; We will later set the image in every pre-page function.
 ; We can also set just one persistent image in .onGUIInit
-AddBrandingImage left 100
+AddBrandingImage left 100u
 
 ; Sets the font of the installer
 SetFont "Comic Sans MS" 8
@@ -62,7 +62,7 @@
 	MessageBox MB_YESNO "We can change the branding image from within a section too!$\nDo you want me to change it?" IDNO done
 		!insertmacro BIMAGE "${NSISDIR}\Contrib\Graphics\Wizard\nsis.bmp" ""
 	done:
-	WriteUninstaller uninst.exe
+	WriteUninstaller $INSTDIR\uninst.exe
 SectionEnd
 
 ;--------------------------------
